///////////////////////////////////////////////////////////
// MOVEWIN.CPP: Moving Window
///////////////////////////////////////////////////////////
#include <owl\applicat.h>
#include <owl\framewin.h>
#include <stdio.h>
#include <string.h>
#pragma hdrstop
#include "movewin.rc"

const int windowX = 200;
const int windowY = 100;
const int moveSize = 20;

//////////////////////////////////
// The main window class.
//////////////////////////////////
class TWndw : public TFrameWindow
{
public:
	TWndw(TWindow *parent, const char far *title);
	~TWndw();

protected:
	void SetupWindow();
	void CleanupWindow();
	void EvTimer(UINT);

	int screenX, screenY;
	int deltaX, deltaY;
DECLARE_RESPONSE_TABLE(TWndw);
};
DEFINE_RESPONSE_TABLE1(TWndw, TWindow)
	EV_WM_TIMER,
	// Place response table entries here.
END_RESPONSE_TABLE;

///////////////////////////////////////////////////////////
// TWndw::TWndw()
///////////////////////////////////////////////////////////
TWndw::TWndw(TWindow *parent, const char far *title)
	:	TFrameWindow(parent, title),
		deltaX(moveSize), deltaY(moveSize)
{
	AssignMenu(MENU_1);
	// Perform object initialization here.

	Attr.X = 50;
	Attr.Y = 50;
	Attr.W = windowX;
	Attr.H = windowY;

	screenX = GetSystemMetrics(SM_CXSCREEN);
	screenY = GetSystemMetrics(SM_CYSCREEN);
}

///////////////////////////////////////////////////////////
// TWndw::~TWndw()
///////////////////////////////////////////////////////////
TWndw::~TWndw()
{
	 // Perform object cleanup here.
}

///////////////////////////////////////////////////////////
// TWndw::SetupWindow()
///////////////////////////////////////////////////////////
void TWndw::SetupWindow()
{
	// Call base class's SetupWindow.
	TFrameWindow::SetupWindow();

	// Perform initialization that requires a
	// valid window handle here.
	SetTimer(1, 750);
}

///////////////////////////////////////////////////////////
// TWndw::CleanupWindow()
///////////////////////////////////////////////////////////
void TWndw::CleanupWindow()
{
	// Perform cleanup that requires a valid
	// window handle here.
	KillTimer(1);
}

void TWndw::EvTimer(UINT)
{
	TRect rect = GetWindowRect();
	if (rect.right > screenX || rect.left < 0)
		deltaX = -deltaX;
	if (rect.top < 0 || rect.bottom > screenY)
		deltaY = -deltaY;

	rect.left += deltaX;
	rect.right += deltaX;
	rect.top += deltaY;
	rect.bottom += deltaY;
	MoveWindow(rect, TRUE);
}

//////////////////////////////////
// The application class.
//////////////////////////////////
class TApp : public TApplication
{
public:
	TApp(): TApplication() {}
	void InitMainWindow();
};

///////////////////////////////////////////////////////////
// TApp::InitMainWindow()
///////////////////////////////////////////////////////////
void TApp::InitMainWindow()
{
	TFrameWindow *wndw = new TWndw(0, "Moving Window");
	SetMainWindow(wndw);
}

///////////////////////////////////////////////////////////
// OwlMain()
///////////////////////////////////////////////////////////
int OwlMain(int, char*[])
{
	return TApp().Run();
}

